﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Mediator.Framework.Metadata
{
    public interface IEntityReference:IEquatable<IEntityReference>
    {
        /// <summary>
        /// Must return Instance as IEntity.
        /// </summary>
        IEntity Instance
        { 
            get;
        }

        Type ServiceType
        { 
            get;
        }

        bool InstanceIs<T>() where T:IEntity;

        T InstanceAs<T>() where T:IEntity;
    }

}
